# Protocol

Lets anyone deploy their own copy of the smart contracts on the platform.

### Deployments

The contracts addresses are the same across all different chains that we supported.

- `Registry.sol`: [0x902a29f2cfe9f8580ad672AaAD7E917d85ca9a2E](https://etherscan.io/address/0x902a29f2cfe9f8580ad672AaAD7E917d85ca9a2E#code)
- `Forwarder.sol`: [0xc82BbE41f2cF04e3a8efA18F7032BDD7f6d98a81](https://etherscan.io/address/0xc82BbE41f2cF04e3a8efA18F7032BDD7f6d98a81#code)
- `ControlDeployer.sol` [0x9559F8A57931b85567350Cb50538ec0fc437F8c9](https://etherscan.io/address/0x9559F8A57931b85567350Cb50538ec0fc437F8c9#code)

**Deployed chains**

- **mainnet**: Ethereum, Polygon, Avalanche C-Chain, Fantom Opera
- **testnet**: Rinkeby (Ethereum), Mumbai (Polygon), Avalanche Fuji Testnet, Fantom Testnet

**Testnet Only Contract Deployments**

- `MintableERC20Permit.sol` (mumbai only): [0xCe8271Ad06e8CB0EE47d1486947313b7c1290D14](https://mumbai.polygonscan.com/address/0xCe8271Ad06e8CB0EE47d1486947313b7c1290D14#code)

## Feedback

If you have any feedback, please reach out to us at support@thirdweb.com.

## Authors

- [thirdweb](https://thirdweb.com)

## License

[Apache 2.0](https://www.apache.org/licenses/LICENSE-2.0.txt)
